;;; -*- mode: scheme; scheme48-package: swank-emacs-i/o -*-

;;;;;; SLIME for Scheme48
;;;;;; Ports instrumented for I/O with a remote Emacs system

;;; This code is written by Taylor Campbell and placed in the Public
;;; Domain.  All warranties are disclaimed.

(define emacs-output-port-handler
        (make-buffered-output-port-handler
         (lambda (session)              ; discloser
           (list 'emacs-output-port
                 (swank-session-id (force session))))
         (lambda (port)                 ; closer
           (error "should not be closing an Emacs output port"
                  port))
         (lambda (port necessary?)      ; buffer emptier
           (let* ((size (provisional-port-index port))
                  (string (make-string size)))
             (copy-bytes! (port-buffer port) 0
                          string             0 size)
             (provisional-set-port-index! port 0)
             (if (maybe-commit)
                 (begin (send-outgoing-swank-message
                            (force (port-data port))
                          `(:READ-OUTPUT ,string))
                        #t)
                 #f)))
         (lambda (port)                 ; readiness tester
           (if (maybe-commit)
               (values #t #t)
               (values #f #f)))))

(define (make-emacs-output-port session-promise)
  (make-buffered-output-port emacs-output-port-handler
                             session-promise
                             (make-byte-vector default-buffer-size 0)
                             0          ; index
                             default-buffer-size))


