;;; -*- Mode: Scheme; scheme48-package: slime48 -*-

;;;; Safe Variant of WITH-HANDLER

;;; This code is written by Taylor R. Campbell and placed in the Public
;;; Domain.  All warranties are disclaimed.

(define (with-safe-handler handler thunk)
  (with-handler (let (($recursive? (make-fluid #f)))
                  (lambda (condition propagate)
                    (if (fluid $recursive?)
                        (propagate)
                        (let-fluid $recursive? #t
                          (lambda ()
                            (handler condition propagate))))))
    thunk))
